import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;

import com.businessobjects.rebean.wi.BinaryView;
import com.businessobjects.rebean.wi.DocumentInstance;
import com.businessobjects.rebean.wi.OutputFormatType;
import com.businessobjects.rebean.wi.ReportEngine;
import com.businessobjects.rebean.wi.ReportEngines;
import com.crystaldecisions.sdk.framework.IEnterpriseSession;
import com.crystaldecisions.sdk.framework.ISessionMgr;
import com.crystaldecisions.sdk.framework.CrystalEnterprise;
import com.crystaldecisions.sdk.occa.infostore.IInfoStore;
import com.crystaldecisions.sdk.occa.infostore.*;
import com.crystaldecisions.sdk.exception.SDKException;
import com.crystaldecisions.sdk.plugin.desktop.folder.*;

/* 
Required jars for XI3:
Program Files/Business Objects/common/4.0/java/lib/rebean.wi.jar
Program Files/Business Objects/common/4.0/java/lib/boconfig.jar
Program Files/Business Objects/common/4.0/java/lib/cecore.jar
Program Files/Business Objects/common/4.0/java/lib/celib.jar
Program Files/Business Objects/common/4.0/java/lib/ceplugins_client.jar
Program Files/Business Objects/common/4.0/java/lib/cesession.jar
Program Files/Business Objects/common/4.0/java/lib/ceutils.jar
Program Files/Business Objects/common/4.0/java/lib/corbaidl.jar
Program Files/Business Objects/common/4.0/java/lib/ebus405.jar
Program Files/Business Objects/common/4.0/java/lib/jtools.jar
Program Files/Business Objects/common/4.0/java/lib/rebean.common.jar
Program Files/Business Objects/common/4.0/java/lib/rebean.jar
Program Files/Business Objects/common/4.0/java/lib/external/xpp3.jar
Program Files/Business Objects/common/4.0/java/lib/wilog.jar
Program Files/Business Objects/common/4.0/java/lib/logging.jar

Required jars for XIr2:
Program Files/Business Objects/common/3.5/java/lib/rebean.wi.jar
Program Files/Business Objects/common/3.5/java/lib/wilog.jar
Program Files/Business Objects/common/3.5/java/lib/cecore.jar
Program Files/Business Objects/common/3.5/java/lib/celib.jar
Program Files/Business Objects/common/3.5/java/lib/ceplugins.jar
Program Files/Business Objects/common/3.5/java/lib/cesession.jar
Program Files/Business Objects/common/3.5/java/lib/corbaidl.jar
Program Files/Business Objects/common/3.5/java/lib/jtools.jar
Program Files/Business Objects/common/3.5/java/lib/rebean.common.jar
Program Files/Business Objects/common/3.5/java/lib/external/xpp3-1.1.3_8.jar
Program Files/Business Objects/common/3.5/java/lib/rebean.jar
Program Files/Business Objects/common/3.5/java/lib/ebus405.jar
Program Files/Business Objects/common/3.5/java/lib/boconfig.jar
*/

public class ExtractXLSApp {


	static IInfoStore oInfoStore;
	static ReportEngines engines;
	static ReportEngine repEngine;
	static Boolean outputCUID=true; // true = CUID, false = name
	static String fileSuffix = "XI3";  // "XI3" or "XIr2"
	
	public static void main(String[] args) 
	throws SDKException,Exception
	{
		String boeUser = "";
		String boePassword = "";
		String boeCMS = "";
		String folderName="";
		
		IInfoObjects myoInfoObjects;
		
		ISessionMgr oSessionMgr = CrystalEnterprise.getSessionMgr();
		IEnterpriseSession oEnterpriseSession = oSessionMgr.logon(boeUser, boePassword, boeCMS, "secEnterprise");
		oInfoStore = (IInfoStore)oEnterpriseSession.getService("", "InfoStore");

		myoInfoObjects = oInfoStore.query("select top 40000 si_id,si_name,si_path from ci_infoobjects where si_kind = 'folder' and si_name = '" + folderName + "'"); 
		
		if(myoInfoObjects.size() == 0)
		{
			System.out.println("Can't find parent folder.");
			return;
		}
		else if(myoInfoObjects.size() > 1)
			System.out.println("Found " + myoInfoObjects.size() + " folders named \"" + folderName + "\", only processing the first one found.");
		
		engines = (ReportEngines) oEnterpriseSession.getService("ReportEngines");
		repEngine = engines.getService(ReportEngines.ReportEngineType.WI_REPORT_ENGINE);
		
		recurseFolder((IInfoObject)myoInfoObjects.get(0),0);
	}
	
	static void recurseFolder (IInfoObject oInfoObject,int level)
	throws Exception
	{
		if(++level > 10)
		{
			System.out.println("Hit max level.");
			return;
		}
			
		String thisPath = getObjectPath(oInfoStore,oInfoObject);
			
		// Get reports
		IInfoObjects oIOs;
		oIOs = oInfoStore.query("select si_update_ts,si_id,si_name,si_cuid from ci_infoobjects where si_kind = 'webi' and si_instance = 0 and si_parentid = " + oInfoObject.getID() );

		for (int x = 0; x < oIOs.size(); x++)
		{
			IInfoObject oIO = (IInfoObject)oIOs.get(x);
			

			File tempFile = new File("c://ExtractXLS//output//" + (outputCUID ? oIO.getCUID() : oIO.getTitle()) + "-" + fileSuffix + ".xls");
			
			if (tempFile.exists())
			{
				System.out.println("\tSkipping: \t" + oIO.getCUID() + "\t" + oIO.getTitle() + "\t" + thisPath + "\t" + oIO.properties().getProperty("SI_UPDATE_TS").toString());
				continue;
			}
			System.out.println("\t" + oIO.getCUID() + "\t" + oIO.getTitle() + "\t" + thisPath + "\t" + oIO.properties().getProperty("SI_UPDATE_TS").toString() );

			DocumentInstance di = null;
			Object ov = null;
			try 
			{			
    			di = repEngine.openDocument(oIO.getID());

    			ov = di.getView(OutputFormatType.XLSDataCentric);
			}
			catch (Exception wtf)
			{
				System.out.println("Failed on report " + oIO.getTitle() + " error: " + wtf.getMessage());
				continue;
			}

			if (ov instanceof BinaryView) 
			{
				BinaryView view = (BinaryView) ov;
				
				tempFile.createNewFile();
				OutputStream os = new FileOutputStream(tempFile);
				view.getContent(os);
				os.close();
			} 
			else 
				System.out.println("Unable to view report in Excel format.");

			di.closeDocument();
		}	

		// recurse directories
		oIOs = oInfoStore.query("select si_id,si_kind,si_path from ci_infoobjects where si_children > 0 and si_parentid = " + oInfoObject.getID());
		for (int x = 0; x < oIOs.size(); x++)
		{
			recurseFolder((IInfoObject)oIOs.get(x),level);
		}
	}		
	static String getObjectPath(IInfoStore iStore,IInfoObject iO)
	throws Exception,SDKException
	{
		String thePath = "";
		IInfoObject lowestFolder = iO;
		while(!(lowestFolder instanceof IFolder))
			lowestFolder = lowestFolder.getParent();
		
		lowestFolder=(IFolder)iStore.query("select si_path from ci_infoobjects where si_id = " + lowestFolder.getID()).get(0);
		
		String[] arPath = ((IFolder)lowestFolder).getPath();

        if (arPath != null)
            for (int index = 0; index < arPath.length; index++)
                thePath = arPath[index] + "/" + thePath; 
               
        return thePath + lowestFolder.getTitle();
	}
}